pcl::HypothesisVerification< ModelT, SceneT > Class Template Referenceabstract

Abstract class for hypotheses verification methods. More...

`#include <pcl/recognition/hv/hypotheses_verification.h>`

Inheritance diagram for pcl::HypothesisVerification< ModelT, SceneT >:

## Public Member Functions

| HypothesisVerification ()
bool | getRequiresNormals ()
void | setResolution (float r)
void | setOcclusionThreshold (float t)
void | setInlierThreshold (float r)
void | getMask (std::vector< bool > &mask)
void | addCompleteModels (std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > &complete_models)
void | addNormalsClouds (std::vector< pcl::PointCloud< pcl::Normal >::ConstPtr > &complete_models)
void | addModels (std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > &models, bool occlusion_reasoning=false)
void | setSceneCloud (const typename pcl::PointCloud< SceneT >::Ptr &scene_cloud)
void | setOcclusionCloud (const typename pcl::PointCloud< SceneT >::Ptr &occ_cloud)
virtual void | verify ()=0

## Protected Attributes

std::vector< bool > | mask_
pcl::PointCloud< SceneT >::ConstPtr | scene_cloud_
pcl::PointCloud< SceneT >::ConstPtr | occlusion_cloud_
bool | occlusion_cloud_set_
pcl::PointCloud< SceneT >::Ptr | scene_cloud_downsampled_
pcl::search::KdTree< SceneT >::Ptr | scene_downsampled_tree_
std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > | visible_models_
std::vector< typename pcl::PointCloud< pcl::Normal >::ConstPtr > | visible_normal_models_
std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > | complete_models_
std::vector< typename pcl::PointCloud< pcl::Normal >::ConstPtr > | complete_normal_models_
int | zbuffer_scene_resolution_
int | zbuffer_self_occlusion_resolution_
float | resolution_
float | inliers_threshold_
float | occlusion_thres_
bool | requires_normals_
bool | normals_set_

## Detailed Description

### template<typename ModelT, typename SceneT>
class pcl::HypothesisVerification< ModelT, SceneT >

Abstract class for hypotheses verification methods.

Author
  Aitor Aldoma, Federico Tombari

Definition at line 56 of file hypotheses_verification.h.

## Constructor & Destructor Documentation

## HypothesisVerification()

template<typename ModelT , typename SceneT >

pcl::HypothesisVerification< ModelT, SceneT >::HypothesisVerification | ( |  | ) |

inline

Definition at line 134 of file hypotheses_verification.h.

## Member Function Documentation

## addCompleteModels()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::addCompleteModels | ( | std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > & | complete_models | ) |

inline

Definition at line 195 of file hypotheses_verification.h.

## addModels()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::addModels | ( | std::vector< typename pcl::PointCloud< ModelT >::ConstPtr > & | models,
|  | bool | occlusion_reasoning = `false`
| ) |  |

inline

Definition at line 217 of file hypotheses_verification.h.

References pcl::occlusion_reasoning::ZBuffering< ModelT, SceneT >::computeDepthMap(), pcl::copyPointCloud(), pcl::occlusion_reasoning::ZBuffering< ModelT, SceneT >::filter(), and pcl::PointCloud< PointT >::isOrganized().

## addNormalsClouds()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::addNormalsClouds | ( | std::vector< pcl::PointCloud< pcl::Normal >::ConstPtr > & | complete_models | ) |

inline

Definition at line 206 of file hypotheses_verification.h.

## getMask()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::getMask | ( | std::vector< bool > & | mask | ) |

inline

Definition at line 183 of file hypotheses_verification.h.

## getRequiresNormals()

template<typename ModelT , typename SceneT >

bool pcl::HypothesisVerification< ModelT, SceneT >::getRequiresNormals | ( |  | ) |

inline

Definition at line 146 of file hypotheses_verification.h.

## setInlierThreshold()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::setInlierThreshold | ( | float | r | ) |

inline

Definition at line 173 of file hypotheses_verification.h.

## setOcclusionCloud()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::setOcclusionCloud | ( | const typename pcl::PointCloud< SceneT >::Ptr & | occ_cloud | ) |

inline

Definition at line 313 of file hypotheses_verification.h.

## setOcclusionThreshold()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::setOcclusionThreshold | ( | float | t | ) |

inline

Definition at line 164 of file hypotheses_verification.h.

## setResolution()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::setResolution | ( | float | r | ) |

inline

Definition at line 155 of file hypotheses_verification.h.

## setSceneCloud()

template<typename ModelT , typename SceneT >

void pcl::HypothesisVerification< ModelT, SceneT >::setSceneCloud | ( | const typename pcl::PointCloud< SceneT >::Ptr & | scene_cloud | ) |

inline

Definition at line 292 of file hypotheses_verification.h.

References pcl::Filter< PointT >::filter(), pcl::VoxelGrid< PointT >::setDownsampleAllData(), pcl::PCLBase< PointT >::setInputCloud(), pcl::search::KdTree< PointT, Tree >::setInputCloud(), and pcl::VoxelGrid< PointT >::setLeafSize().

## verify()

template<typename ModelT , typename SceneT >

virtual void pcl::HypothesisVerification< ModelT, SceneT >::verify | ( |  | ) |

pure virtual

Implemented in pcl::GlobalHypothesesVerification< ModelT, SceneT >, pcl::GreedyVerification< ModelT, SceneT >, and pcl::PapazovHV< ModelT, SceneT >.

## Member Data Documentation

## complete_models_

template<typename ModelT , typename SceneT >

std::vector<typename pcl::PointCloud<ModelT>::ConstPtr> pcl::HypothesisVerification< ModelT, SceneT >::complete_models_

protected

Definition at line 97 of file hypotheses_verification.h.

## complete_normal_models_

template<typename ModelT , typename SceneT >

std::vector<typename pcl::PointCloud<pcl::Normal>::ConstPtr> pcl::HypothesisVerification< ModelT, SceneT >::complete_normal_models_

protected

Definition at line 99 of file hypotheses_verification.h.

## inliers_threshold_

template<typename ModelT , typename SceneT >

float pcl::HypothesisVerification< ModelT, SceneT >::inliers_threshold_

protected

Definition at line 116 of file hypotheses_verification.h.

## mask_

template<typename ModelT , typename SceneT >

std::vector<bool> pcl::HypothesisVerification< ModelT, SceneT >::mask_

protected

Definition at line 63 of file hypotheses_verification.h.

## normals_set_

template<typename ModelT , typename SceneT >

bool pcl::HypothesisVerification< ModelT, SceneT >::normals_set_

protected

Definition at line 131 of file hypotheses_verification.h.

## occlusion_cloud_

template<typename ModelT , typename SceneT >

pcl::PointCloud<SceneT>::ConstPtr pcl::HypothesisVerification< ModelT, SceneT >::occlusion_cloud_

protected

Definition at line 72 of file hypotheses_verification.h.

## occlusion_cloud_set_

template<typename ModelT , typename SceneT >

bool pcl::HypothesisVerification< ModelT, SceneT >::occlusion_cloud_set_

protected

Definition at line 74 of file hypotheses_verification.h.

## occlusion_thres_

template<typename ModelT , typename SceneT >

float pcl::HypothesisVerification< ModelT, SceneT >::occlusion_thres_

protected

Definition at line 121 of file hypotheses_verification.h.

## requires_normals_

template<typename ModelT , typename SceneT >

bool pcl::HypothesisVerification< ModelT, SceneT >::requires_normals_

protected

Definition at line 126 of file hypotheses_verification.h.

## resolution_

template<typename ModelT , typename SceneT >

float pcl::HypothesisVerification< ModelT, SceneT >::resolution_

protected

Definition at line 111 of file hypotheses_verification.h.

## scene_cloud_

template<typename ModelT , typename SceneT >

pcl::PointCloud<SceneT>::ConstPtr pcl::HypothesisVerification< ModelT, SceneT >::scene_cloud_

protected

Definition at line 67 of file hypotheses_verification.h.

## scene_cloud_downsampled_

template<typename ModelT , typename SceneT >

pcl::PointCloud<SceneT>::Ptr pcl::HypothesisVerification< ModelT, SceneT >::scene_cloud_downsampled_

protected

Definition at line 79 of file hypotheses_verification.h.

## scene_downsampled_tree_

template<typename ModelT , typename SceneT >

pcl::search::KdTree<SceneT>::Ptr pcl::HypothesisVerification< ModelT, SceneT >::scene_downsampled_tree_

protected

Definition at line 84 of file hypotheses_verification.h.

## visible_models_

template<typename ModelT , typename SceneT >

std::vector<typename pcl::PointCloud<ModelT>::ConstPtr> pcl::HypothesisVerification< ModelT, SceneT >::visible_models_

protected

Definition at line 91 of file hypotheses_verification.h.

## visible_normal_models_

template<typename ModelT , typename SceneT >

std::vector<typename pcl::PointCloud<pcl::Normal>::ConstPtr> pcl::HypothesisVerification< ModelT, SceneT >::visible_normal_models_

protected

Definition at line 93 of file hypotheses_verification.h.

## zbuffer_scene_resolution_

template<typename ModelT , typename SceneT >

int pcl::HypothesisVerification< ModelT, SceneT >::zbuffer_scene_resolution_

protected

Definition at line 103 of file hypotheses_verification.h.

## zbuffer_self_occlusion_resolution_

template<typename ModelT , typename SceneT >

int pcl::HypothesisVerification< ModelT, SceneT >::zbuffer_self_occlusion_resolution_

protected

Definition at line 107 of file hypotheses_verification.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/recognition/include/pcl/recognition/hv/hypotheses_verification.h